package com.applayos.GroupLinkApplay;

import org.apache.cordova.CordovaPlugin;
import org.apache.cordova.CallbackContext;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import com.grouplinknetwork.GroupLink;

import android.content.Context;

import android.util.Log;
import java.util.logging.Logger;
import java.util.logging.Level;

/**
 * This class echoes a string called from JavaScript.
 */

public class GroupLinkApplay extends CordovaPlugin {

    private Context context;
    public static final String TAG = "GroupLinkApplay";
    public static Logger logger = Logger.getAnonymousLogger();

    @Override
    public boolean execute(String action, JSONArray args, CallbackContext callbackContext) throws JSONException {
        if (action.equals("echoTest")) {
            String mensagemAlerta = args.getString(0);
            this.echoMethod(mensagemAlerta, callbackContext);
            return true;
        }
        if (action.equals("start")) {
            String tokenTexto = args.getString(0);
            this.startMethod(tokenTexto, callbackContext);
            return true;
        }
        return false;
    }

    private void echoMethod(String message, CallbackContext callbackContext) {
        if (message != null && message.length() > 0) {
            callbackContext.success(message);
        } else {
            callbackContext.error("Houve algum erro no texto");
        }
    }

    private void startMethod(String token, CallbackContext callbackContext) {
        context = cordova.getActivity().getApplicationContext();
        try {
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START:try >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          GroupLink.register(context,token,false);
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> FIM:try >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          callbackContext.success("GroupLink ok");
        }
        catch(Exception e) {
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> START:catch >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          logger.log(Level.SEVERE, "Erro", e);
          Log.e(TAG,">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> FIM:catch >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>");
          callbackContext.error("Ocorreu um erro com GroupLink");
        }
    }
}
